<?php

chdir('../../');
include(dirname(__FILE__) . "/../../include/config.php");
include_once($config["base_path"] . "/plugins/thold/thold-functions.php");
include_once($config["base_path"] . "/lib/snmp.php");
include_once($config["base_path"] . "/lib/ping.php");

cacti_log("Checking Manage", true, "MANAGE");

$db = mysql_connect("$database_hostname", "$database_username", "$database_password");
mysql_select_db("$database_default",$db);

$uptimearray = "SELECT host.id, host.hostname, host.description, host.snmp_community, host.snmp_version, host.snmp_username, host.snmp_password, host.snmp_port, host.snmp_timeout, manage_host.uptime, manage_host.statut, manage_host.force  FROM host,manage_host where manage = 'on' and disabled <> 'on' and host.id=manage_host.id";
$queryrows = db_fetch_assoc($uptimearray) or die (mysql_error() );


foreach ($queryrows as $q_row) {
  print "id : " . $q_row["id"];

  $reboot = '0';

//  $uptimearray2 = "SELECT * FROM manage_host where id='" . $q_row["id"] . "'";
//  $queryrows2 = db_fetch_assoc($uptimearray2);

//  foreach ($queryrows2 as $q_row2) {
//    if ($q_row["id"] == $q_row2["id"]) {
//      $old_uptime = $q_row2["uptime"];
//    }
//  }
  $old_uptime = $q_row["uptime"];


  if ($old_uptime == "") {
    $old_uptime = "0";
  }

  print " - statut : " . $q_row["statut"] . "\n";

  $result = "";
  $method = read_config_option("manage_method");
  print " method : " . $method . "\n";
  
  if ( ($q_row["force"] <> $method) and ($q_row["force"] <> "9") and ($q_row["force"] <> "") )  {
    $method = $q_row["force"];
	print " force - new method : " . $method . "\n";
  }
  
  switch ($method){
    case "0" :
	  $result = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.1.3.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);
    break;
    case "1" :
	  $result = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.1.1.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);
    break;
    case "2" :
	  $ping = new Net_Ping;
	  $ping->ping(3, 2, 400, 1);
	  if ($ping) {
	    $result = "OK";
	  } else {
	    $result = "";
	  }
    break;
    case "3" :
	  $ping = new Net_Ping;
	  $ping->ping(3, 1, 400, 1);
	  if ($ping) {
	    $result = "OK";
	  } else {
	    $result = "";
	  }
    break;		
  }


			
					
  
  $new_uptime = "";
  if (($result == "") || ($result == "U")) {
    print " Host : " . $q_row["hostname"] . " (" . $q_row["description"] . ") is not responding !\n";
    $r="down";
  } else {
  
      if ($method == "0"){
	    $new_uptime = $result;
	  }
	  
	  if ($method == "1") {
	    $new_uptime = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.1.3.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);
	  }

	  if ($new_uptime == "") {
        $new_uptime = "0";
      }
  
      print " Host : " . $q_row["hostname"] . " (" . $q_row["description"] . "), old uptime is : " . $old_uptime . ", new is : " . $new_uptime . "\n";	
      $r="up";
  }

  if ($q_row["statut"] == $r) {
      print " + host : nothing to do...\n";
  } else {
    db_execute("UPDATE manage_host SET statut = '" . $r ."' where id='" . $q_row["id"] . "'");
	if ($r == 'down') {
      db_execute("UPDATE manage_host_services SET statut = 'down' where id='" . $q_row["id"] . "'");
	}
	if ( (($q_row["statut"] <> 'prob')  and ($r <> 'prob')) || (   $r == 'down')   ) {
	  logger("", $q_row["id"], $r, "Host is ", $q_row["hostname"] , $q_row["description"]);
    }
  }

  if ($r == 'up') {
    db_execute("UPDATE manage_host SET uptime = '" . $new_uptime ."' where id='" . $q_row["id"] . "'");

    if ($new_uptime < $old_uptime) {
      logger("", $q_row["id"], "rebooted", "Host has ", $q_row["hostname"] , $q_row["description"]);
	  $reboot = '1';
    }
    $uptimearray3 = "SELECT * FROM manage_host_services where id='" . $q_row["id"] . "'";
    $queryrows3 = db_fetch_assoc($uptimearray3);

	global $config, $database_default;
	$p = dirname(__FILE__);

	foreach ($queryrows3 as $q_row3) {
print "x";
  	  if ($config["cacti_server_os"] == "unix") {
		$command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . $p . "/check-tcp.php " . $q_row["hostname"] . " " . $q_row3["services"];
	  } else {
		$command_string = read_config_option("path_php_binary");
	  	$extra_args = "-q " . strtolower($p . "/check-tcp.php " . $q_row["hostname"] . " " . $q_row3["services"] );
  	  }

      print " + service :  " . $q_row3["services"] . " : " . $q_row3["statut"] . "\n";
	  $r2=exec_background($command_string, $extra_args);
//	  print $r2;

	  if ($r2 == 'down') {
        db_execute("UPDATE manage_host SET statut = 'prob' where id='" . $q_row["id"] . "'");
	  }

	  if ( ($r2 == $q_row3["statut"]) and ($reboot == '0'))  {
	    print " + services : nothing to do...\n";
	  } else {
	    logger($q_row3["services"], $q_row["id"], $r2, "Service is ", $q_row["hostname"] , $q_row["description"]);
		//met  jour le statut
		db_execute("UPDATE manage_host_services SET statut = '" . $r2 ."' where id='" . $q_row["id"] . "' and services='" . $q_row3["services"] . "'");
	  }

    }
  }
  
  if ($r == 'down') {
    $today = getdate();
    $date = $today['year']."/".$today['mon']."/".$today['mday'].", ".$today['hours'].":".$today['minutes'].":".$today['seconds'];
//  print $date . "\n";
    $uptimearray4 = "SELECT * FROM manage_host_services where id='" . $q_row["id"] . "'";
    $queryrows4 = db_fetch_assoc($uptimearray4);
	foreach ($queryrows4 as $q_row4) {
      db_execute("INSERT INTO manage_alerts ( idh , datetime , ids , message, ida ) VALUES ('" . $q_row["id"] . "', '" . $date . "', '" . $q_row4["services"] . "', 'down', '')");
	}
  }
  
}

$today = getdate();
$poller_date = $today['year']."-".$today['mon']."-".$today['mday'].", at ".$today['hours'].":".$today['minutes'].":".$today['seconds'];
print $poller_date;
db_execute("UPDATE settings SET value = '" . $poller_date . "' where name='manage_date'");




/* exec_background - executes a program in the background so that php can continue
     to execute code in the foreground
   @arg $filename - the full pathname to the script to execute
   @arg $args - any additional arguments that must be passed onto the executable */
function exec_background($filename, $args = "") {
	global $config;

	if (read_config_option("log_verbosity") == POLLER_VERBOSITY_DEBUG) {
		cacti_log("DEBUG: About to Spawn a Remote Process [CMD: $filename, ARGS: $args]", true, "POLLER");
	}

	if (file_exists($filename)) {
//		if ($config["cacti_server_os"] == "win32") {
//			pclose(popen("start \"Cactiplus\" /I \"" . $filename . "\" " . $args, "r"));
//		}else{

			//exec($filename . " " . $args . " > /dev/null &");
			print " exec -";
			exec($filename . " " . $args, $output);
			print $output[0] . "-\n";
return $output[0];
//		}
	}
}


function logger($svc, $id, $val, $typ, $hn, $hd) {
//print $svc . "-" . $id . "-" . $val . "-" . $typ . "-" . $hn . "-" . $hd . "\n";
  $global_alert_address = read_config_option("alert_email");
  $manage_events = read_config_option("manage_events");

  $today = getdate();
  $date = $today['year']."/".$today['mon']."/".$today['mday'].", ".$today['hours'].":".$today['minutes'].":".$today['seconds'];
//  print $date . "\n";
  db_execute("INSERT INTO manage_alerts ( idh , datetime , ids , message, ida ) VALUES ('" . $id . "', '" . $date . "', '" . $svc . "', '" . $val . "', '')");

  if ($manage_events <> '5') {
    print " + mail demande : " . $global_alert_address . "\n";
	$h='';
	if ($val == 'up') {
	  if (($manage_events == '0') || ($manage_events == '3')) {
	    print " + OK up\n";
		$h='UP';
	  }
	}
	if ($val == 'down') {
	  if (($manage_events == '1') || ($manage_events == '3') || ($manage_events == '4')) {
	    print " + OK down\n";
        $h='DOWN';
	  }
	}
	if ($val == 'rebooted') {
	  if (($manage_events == '2') || ($manage_events == '4')) {
	    print " + OK reboot\n";
        $h='Reboot';
	  }
	}
	if ($h <> '') {
	  $g='Port ' . strtolower($svc);
	  if ($svc == '') {
	    $g='Host ';
	  }
	  thold_mail($global_alert_address, '', $h . ' event detected for host ' . $hd . ' (' . $hn . ')', $g . ' is ' . $h . '.', '');
	} else {
	  print " + No mail for this event.\n";
	}
  }
}


?>

